const byte debug = 2;
const int decl =  1000; // 1500  ok    2047;   assez petit pour déclencher et pas trop pour pas réagir au cliqueur ni à la mise en place de la fleche
// 1 => valeur capteur
// 2 => shoot
// 3 => senddata
// 4 => batterie
// 5 => all

const char *ver = "3.3";

// ********************************************************************************************************************
// ********************************************************************************************************************
// ********************************************************************************************************************

#include <Wire.h>
#include <WiFiManager.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>
#include <WiFiClientSecure.h> 

#define WIFI_TIMEOUT 20
#define HTTP_TIMEOUT 20

uint16_t      port = 443;                  //  port du serveur HTTP sécurisé
String        host = "loloz3.ddns.net";    //  A changer avec votre serveur

ESP8266WiFiMulti WiFiMulti;
HTTPClient https;

// ********************************************************************************************************************
// ********************************************************************************************************************
// ********************************************************************************************************************

// definition variables /////////////////////////////////////////
const int MPU_addr=0x68; // I2C address of the MPU-6050 (GY-521)
int16_t AcX,AcY,AcZ,Tmp,GyX,GyY,GyZ;
char tmp_str[7]; // temporary variable used in convert function
char* convert_int16_to_str(int16_t i) {
  sprintf(tmp_str, "%6d", i);
  return tmp_str;
}

const int t = 25;               // nb collection / s   ex :  25 => 40 data/s      50 => 20 data/s       100 => 10 data/s
const int maxdata = 600;        // buffer de 600 données max
bool Shoot = false;             // on n'a pas tirer
bool ShootEnd = false;          // on n'est pas en fin de tir (donnée envoyé)
String id = "-";                // id de l'AT ... mais plus utile
int o = 1;
int o2, L, L2;
int p = 0;
int v = 0;
int bat;                        // % batterie
int led1 = 0;                   // init compteur pour led
int xAccl, yAccl, zAccl, lastx;
int datax[maxdata];             // Buffer des data que l'on renregistre en boucle
int datax2[maxdata];            // Buffer des data calé sur le tir
int datay[maxdata];             // pas utilisé car bug... ni y , ni z

//                   **             ***
//                  *  *     moy2   ***
//                 *    ***************
//                *                 ***
//               *                  ***
//    moy3      *                   ***
// *************                    ***
//             t2       t1         t0
//
// on demarre arc baissé en (moy3)
// on lève l'arc (t2 debut du tir)
// on monte l'arc au dessus de la cible et on redescend dans le centre à t1
// on maintien l'arc en (moy2) jusqu'au tir à t0

int com = 0;    // variable de tenue de bras (0 ok , 1 la bras baisse...)
int t0 = 0;     // ou (ts) Temps Start      t0 est la detection du tir
int t1 = 0;     // ou (tm) Temps Maintient  t1 est le temps de maintien
int t2 = 0;     // ou (tt) Temps Total      t2 est le temps total de tir

int moy2;       // moyenne au moment du maintien
int moy3;       // moyenne avant de commencer le tir

float tenue = 0;// pente tenu de bras
float T = 0;    // Température du capteur

int hb = 0;     // HeartBeat ... sa marche mais j'ai fait compliqué
int hb2 = 0;    // HeartBeat ...    "        "              "

String httpRequestData;  // POST data


// ********************************************************************************************************************
// ********************************************************************************************************************
// ********************************************************************************************************************

void setup() {
  pinMode(LED_BUILTIN, OUTPUT);
  Serial.begin(115200);   // Initialise Serial Communication, set baud rate = 115200
  bat = getLevel();       // Lecture de la batterie
  WiFi.mode(WIFI_STA);    // explicitly set mode, esp defaults to STA+AP
  WiFiManager wm;         // Définition de wm WifiManager

  bool res;
  res = wm.autoConnect("ArcherTrainer",""); // si pas de wifi connu on se met en AP avec ArcherTrainer et on attend ici
  if(!res) {
       Serial.println("Failed to connect");
       ESP.restart(); // pas de connexion Wifi bonne (mauvais mot de passe ...) on reboot
   } else {
        //si on est là, c'est que l'on est conecté au WiFi !!
        Serial.println("connected...yeey :)");
  }

  // pas très utile ... mais je laisse pour debug
  Serial.println("");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
  Serial.print("MAC address: ");
  Serial.println(WiFi.macAddress());

  httpRequestData.reserve(10000);  // on réserve de la memoire dans le setup pour faire POST data

  // initialize GY-521 communication
  Wire.begin();
  Wire.beginTransmission(MPU_addr);
  Wire.write(0x6B); // PWR_MGMT_1 register
  Wire.write(0); // set to zero (wakes up the MPU-6050)
  Wire.endTransmission(true);

  // lecture de la Température... qui n'est pas terrible...
  readdata();
  // on envoie IP / MAC au serveur pour que l'on voit l'AT dans la liste des connectés
  senddata();

///// FIN du SETUP  /////////////////////////////////////////////////////////////
}

// ********************************************************************************************************************
// ********************************************************************************************************************
// ********************************************************************************************************************
// ********************************************************************************************************************
// ********************************************      MAIN LOOP     ****************************************************
// ********************************************************************************************************************
// ********************************************************************************************************************
// ********************************************************************************************************************
// ********************************************************************************************************************

void loop() {
  readdata();                                                       // on lit les données
  led();                                                            // gestion de la LED
  if (ShootEnd==true) { lastx=xAccl; ShootEnd = false; hb=1;}       // après le tir, on met à jour la dernière valeur pour pas avoir de pic et donc un faux tir.
  if (((xAccl>lastx+decl)||(xAccl<lastx-decl))&&(Shoot==false)) {   // on vient de tirer !!!
    if (debug>=2){Serial.println("shoot !");}
    Shoot = true; 
    o2 = o + 20;                                                    // et enregistre encore 1es 20 prochaines données
    if (o2>=maxdata) { o2 -=maxdata; }
  }
  if ((Shoot==true)&&(o==o2)) { shoot(); ShootEnd = true; Shoot=false; } // on traite le tir puis on signifie qu'on a fini pour reprendre
  o++; 
  if (o>maxdata) {o=0;}                                             // on boucle pour pas dépasser le buffer
  delay(t);                                                         // petite pause et ainsi collecter plus ou moins de data


  ///  heartbeat : si L>80 on ne bouge pas si L<80 on bouge l'arc !
  hb += 1; hb2 += 1;
  if ((L<80)&&(hb2>5)) { hb = 1; }  // on filtre 5 fois puis on remet le compteur à 1
  if (L>80) { hb2 = 0; }
  if (hb>4300) {hb = 0; senddata();}                   // si AT ne bouge pas environ 2 minutes => heartbeat ! (dire que l'on est toujours connecté)
  if (debug==1) { Serial.print("hb: ");Serial.println(hb); }
}

// ********************************************************************************************************************
// ********************************************************************************************************************
// ***********************************************        SHOOT !!       **********************************************
// ********************************************************************************************************************
// ********************************************************************************************************************

void shoot()
{
digitalWrite(LED_BUILTIN, LOW);
if (debug==2) { Serial.println(" Shoot !!!"); }
datax[maxdata]=datax[maxdata-1];                   ///  fix bug pas trouvé !!!

// ****************  mise en forme tableau x dans datax2 *********************
// ****************  les data sont prises à l'inverse ************************
int x = 0;
int j=o; // -1
do {
  datax2[x]=datax[j];
  j--;
  if (j<0) {j=maxdata;}
  x++;
 } while (x<=maxdata);  

// ***************************************************************************
if (debug==2) {
 Serial.print("x : ");
 for (x = 0; x <= 30; x++) { Serial.print(datax2[x]); Serial.print(","); }
 Serial.println("");
}
// *************** recherche de la valeur la plus basse ***********************
int minix = 10000;
for (x = t0+5; x <= maxdata; x++) {   // +5 pour eviter le déclenchement du cliqueur
  if (datax2[x]<minix){ minix = datax2[x];}
}
// *************** on passe toutes les valeurs positive ! *********************
for (x = 0; x <= maxdata; x++) {
  datax2[x]= datax2[x]- minix;
}

// A présent on chercher les valeurs t0, t1, t2 ...
// Temps de sequence  Installation = t2 / Maintien = t1 / déclenchement t0
t0=0; 
t1=0; 
t2=0;

//  t0  Déclenchement + cliqueur
bool flagt0 = true;
for (x = 15 ; x <= maxdata; x++) {  // 15 = on avance un peu et on cherche quand on est stable
 if ((datax2[x]<datax2[x+1]+30)&&
     (datax2[x]>datax2[x+1]-30)&&
     (datax2[x]<datax2[x+2]+30)&&
     (datax2[x]>datax2[x+2]-30)&&
     (datax2[x]<datax2[x+3]+30)&&
     (datax2[x]>datax2[x+3]-30)&&
     (flagt0==true)
    ) {                             // ici on est stable et donc on est a t0
      t0=x+3;                       // on retrouve du stable sur 4 points espacés x +1 +2 +3    (x+3) pour pousser un peu plus loin
      flagt0=false;                 // et on arrete de chercher
      }        
}
 
// *************** on regarde moyenne avant déclenchement sur 10 points *********************
moy2 = (datax2[t0+10]+  // moyenne sur 10 valeurs ... de t0 + 10 pour le cliqueur ...
        datax2[t0+11]+
        datax2[t0+12]+
        datax2[t0+13]+
        datax2[t0+14]+
        datax2[t0+15]+
        datax2[t0+16]+
        datax2[t0+17]+
        datax2[t0+18]+
        datax2[t0+19]
        )/10;
        
//  t1 Maintien
bool flagt1 = true;
for (x = t0+20; x <= maxdata; x++) {   // +20 pour eviter le déclenchement du cliqueur
  if (((datax2[x]>moy2+90)||(datax2[x]<moy2-90))&&(flagt1==true)) { t1 = x-t0-6; flagt1=false; }  // -6 pour le delta -90/+90
}

if (debug==2) { Serial.print("t1: ");Serial.println(t1); }
if (debug==2) { Serial.print("moy2: ");Serial.println(moy2); }

// *************** on recherche de t2 (début du tir) à partir de t1 et regarde la moyenne *********************
bool flagt2 = true;
for (x = t1+70 ; x <= maxdata; x++) {  // +70 = on passe le pique
 if ((datax2[x]<datax2[x+10]+40)&&
     (datax2[x]>datax2[x+10]-40)&&
     (datax2[x]<datax2[x+20]+40)&&
     (datax2[x]>datax2[x+20]-40)&&
     (datax2[x]<datax2[x+30]+40)&&
     (datax2[x]>datax2[x+30]-40)&&
     (((datax2[x]+datax2[x+10]+datax2[x+20]+datax2[x+30])/4>moy2+100)||
      ((datax2[x]+datax2[x+10]+datax2[x+20]+datax2[x+30])/4<moy2-100))&&
      (flagt2==true)
    ) { // on est stable et normalement a t2
        moy3 = (datax2[x]+datax2[x+10]+datax2[x+20]+datax2[x+30])/4;
      t2=x-t0+5; flagt2=false;}  // on retrouve du stable sur 3 points espacés x +10 +20    +5 pour pousser un peu plus loin
}
if (debug==2) { Serial.print("t2: ");Serial.println(t2); }
if (debug==2) { Serial.print("moy3: ");Serial.println(moy3); }

// *****************  analyse tenu du bras (pour les débutants) *****************  
// une droite c'est y = ax + b 
// point 1  x1 = t0 + 5
//          y1 = datax2[x1]
// point 2  x2 = t1
//          y2 = datax2[x2]
//
// on veut a (la pente)  tenue = (y2-y1)/(x2-x1)       L'idée est là ... mais ça ne marche pas bien ;-)
 tenue = ((datax2[t1]-datax2[t0+5])*100)/(t0+5-t1);
 if (tenue<-35) {
  if (debug==2) { Serial.println("Attention tenue de bras !!!!"); }
  com = 1;} 
  else { com =0; }
if (debug==2) { Serial.print("a: ");Serial.println(tenue); }

// ************************* analyse precision  **********************************

// on mesure l'écart en max en min du temps de maintien
int mmax=-20000;
int mmin=20000;
for (int x = t0+10; x <= t1-10; x++) {  // on prend plus court +10 et -10
if (datax2[x]>mmax) { mmax = datax2[x];}
if (datax2[x]<mmin) { mmin = datax2[x];}
} 
p = 101-(mmax-mmin)/10;
if (debug==2) { Serial.print("max : "); Serial.println(mmax); }
if (debug==2) { Serial.print("min : "); Serial.println(mmin); }
if (debug==2) { Serial.print("Précision : "); Serial.println(p); }

// ******************* on inverse les datas ou pas  **********************************
// certain capteur m'ont fait des valeurs inversé ! (à revoir) ... donc je suis certain de mettre mes données dans le bon sens
if (moy3<moy2) {
for (x = 0; x <= maxdata; x++) { 
  datax2[x] = (2 * moy2) - datax2[x];
}
}

// ***************************************************************************

if (debug==2) { Serial.print("moyyyy: "); Serial.println(abs(moy3-moy2)); }


if (t1>30) {        // pour eviter le déclenchement d'un faux tir lorsque l'on pose l'arc (un peu fort) sur son repose arc !!!
v++; senddata();    // on increment les volées et on envoie uniquement si t1 (temps de maintien) > 30 car t1<30 on vient de poser l'arc
}   

}

// ********************************************************************************************************************
// ********************************************************************************************************************
// ********************************************************************************************************************

void readdata ()
{
  Wire.beginTransmission(MPU_addr);
  Wire.write(0x3B); // starting with register 0x3B (ACCEL_XOUT_H) [MPU-6000 and MPU-6050 Register Map and Descriptions Revision 4.2, p.40]
  Wire.endTransmission(false); // the parameter indicates that the Arduino will send a restart. As a result, the connection is kept active.
  Wire.requestFrom(MPU_addr, 7*2, true); // request a total of 7*2=14 registers
  
  // "Wire.read()<<8 | Wire.read();" means two registers are read and stored in the same variable
  AcX = Wire.read()<<8 | Wire.read(); // reading registers: 0x3B (ACCEL_XOUT_H) and 0x3C (ACCEL_XOUT_L)
  AcY = Wire.read()<<8 | Wire.read(); // reading registers: 0x3D (ACCEL_YOUT_H) and 0x3E (ACCEL_YOUT_L)
  AcZ = Wire.read()<<8 | Wire.read(); // reading registers: 0x3F (ACCEL_ZOUT_H) and 0x40 (ACCEL_ZOUT_L)
  Tmp = Wire.read()<<8 | Wire.read(); // reading registers: 0x41 (TEMP_OUT_H) and 0x42 (TEMP_OUT_L)
  GyX = Wire.read()<<8 | Wire.read(); // reading registers: 0x43 (GYRO_XOUT_H) and 0x44 (GYRO_XOUT_L)
  GyY = Wire.read()<<8 | Wire.read(); // reading registers: 0x45 (GYRO_YOUT_H) and 0x46 (GYRO_YOUT_L)
  GyZ = Wire.read()<<8 | Wire.read(); // reading registers: 0x47 (GYRO_ZOUT_H) and 0x48 (GYRO_ZOUT_L)

  T =(Tmp/340.00+36.53-11);  //-10   a revoir !!! ou supprimer

  lastx = xAccl;   // dernier valeur lu
  
  // Convert the data to 12-bits
  xAccl = AcY/16;
  yAccl = AcX/16;
  zAccl = AcZ/16;
 
  datax[o]= xAccl;   // on enregistre les x
  datay[o]= yAccl;   // on prend aussi les y  
  L = 101-sqrt(sq(datax[o]-datax[o-1])+sq(datay[o]-datay[o-1]))/10;  // calcul du vecteur de déplacement

  if (debug==1) {
   Serial.print("L : "); Serial.print(L);
   Serial.print("x : "); Serial.print(xAccl);
   Serial.print(" y : "); Serial.println(yAccl);
   Serial.print(" T : "); Serial.println(T);
  }
}

// ********************************************************************************************************************
// ********************************************************************************************************************
// ********************************************************************************************************************

void senddata()
{
  if ((WiFiMulti.run() == WL_CONNECTED)) {
  std::unique_ptr<BearSSL::WiFiClientSecure>client(new BearSSL::WiFiClientSecure);
  client->setInsecure();
  
  // HTTPClient https;
  bat = getLevel();                      // on lit la batterie
  String MAC = WiFi.macAddress();        // la MAC addresse
  //String IP = WiFi.localIP().toString(); // l'IP local  .. mais pas utile
  String batdata = String(bat);          //String to interger conversion
  String verdata = String(ver);
  String nbdata = String(v);
  String pdata = String(p);
  String ttdata = String(t2);
  String tmdata = String(t1);
  String tsdata = String(t0);
  String comdata = String(com);
  String tmpdata = String(T);

  // Key API                             // on calcul la clé API a partir de la MAC addresse
  String k1 = MAC.substring(0, 2);
  String k2 = MAC.substring(3, 5);
  String k3 = MAC.substring(6, 8);
  String k4 = MAC.substring(9, 11);
  String k5 = MAC.substring(12, 14);
  String k6 = MAC.substring(15, 17);
  // on les converti en char
  char kc1[3]; k1.toCharArray(kc1, 3);
  char kc2[3]; k2.toCharArray(kc2, 3);
  char kc3[3]; k3.toCharArray(kc3, 3);
  char kc4[3]; k4.toCharArray(kc4, 3);
  char kc5[3]; k5.toCharArray(kc5, 3);
  char kc6[3]; k6.toCharArray(kc6, 3);
  // puis en nombre... integer
  int key1 = strtoul(kc1, NULL, 16);
  int key2 = strtoul(kc2, NULL, 16);
  int key3 = strtoul(kc3, NULL, 16);
  int key4 = strtoul(kc4, NULL, 16);
  int key5 = strtoul(kc5, NULL, 16);
  int key6 = strtoul(kc6, NULL, 16);
  // maintenant formule magique !     /// à changer si on veut un serveur perso // ...pas très utile car je montre mon code ;-)
  int key = (key1 xor key3 xor key6 xor 20)*256 + (key2 xor key4 xor key5 xor 165);
  // conversion en Hex  
  String keydata = String(key, HEX);
  //Serial.print("[key] ");Serial.println(keydata);

    
  String url = "/ArcherTrainer/API.php";

  //Post Data
  httpRequestData = "MAC=" + MAC + "&key=" + keydata + "&bat=" + batdata + "&ver=" + verdata + "&Tmp=" + tmpdata +"&nb=" + nbdata +"&p=" + pdata + "&tt=" + ttdata + "&tm=" + tmdata + "&ts=" + tsdata + "&com=" + comdata+ "&datax=";
  for (int x=1; x<=maxdata; x++) {httpRequestData += String(datax2[x]) + ",";} 
 
  if (hb == 0) {httpRequestData = "MAC=" + MAC + "&key=" + keydata + "&bat=" + batdata + "&ver=" + verdata + "&Tmp=" + tmpdata;  }

  if (debug==3) { Serial.println(httpRequestData); }
  
  if (https.begin(*client, host, port, url, true)) {  // HTTPS
      https.addHeader("Content-Type", "application/x-www-form-urlencoded");
 
      if (debug==3) { Serial.print("[HTTPS] POST...\n"); }
      
      // start connection and send HTTP header
      int httpCode = https.POST(httpRequestData);
      String payload = https.getString();    //Get the response payload
      int PositionOfTag = payload.indexOf("id=");
      id = payload.substring(PositionOfTag+3,PositionOfTag + payload.substring(PositionOfTag).indexOf(';'));
      // le serveur retourne l'ID de l'AT ... mais c'est plus utile .. je laisse ..
    
      if (debug==3) { Serial.print(String(httpCode) + " ");   //Print HTTP return code
                      Serial.println(payload); }    //Print request response payload
      https.end();  //Close connection
    }
  }
}

float getLevel(){          // on lit la valeur de batterie
  float raw = analogRead(A0);
  int level = map(raw, 208, 327, 0, 100);  // Avec une résistance 1M - With a 1M resistor
  if ( level < 0 ) { level = 0; }
  if ( level > 100 ) { level = 100; }
  if (debug==4) {
   Serial.print("Level batterie : "); Serial.println(level);
   Serial.print("raw: "); Serial.println(raw);
   level = raw;
  }
  return level;
}

void led () {               // on fait clignoter la LED quand l'AT enregistre
if (led1<=10) { digitalWrite(LED_BUILTIN, LOW); }
if (led1>10) { digitalWrite(LED_BUILTIN, HIGH);}
led1 +=1;
if (WiFi.status() != WL_CONNECTED) {digitalWrite(LED_BUILTIN, LOW);}
if (led1==20) { led1=0;}
}
